/*
 * HiGH SOCiETY 
 *
 * index
 *
 * all time hero: stage
 * based on 3d-demo by Locke
 *
 *
 *
 * okay,  3d-abilities are fully implemented, werden nur nicht benutzt.
 * (auer screen-clear und so...) 
 *
 * das wirklich lame an der sache ist, da der ganze screen pro frame
 * komplett aufgebaut wird...  :-/
 *
 */

#define MAXINFO 120+4   // eintrge in scrollfeld.=games+4

#include <ultra64.h>
#include "demo.h"

#define MAXSTARS 35  // =55 stars / plane = 55*5
#define RGB(r,g,b) ((r<<11)|(g<<6)|(b<<1)) // (c) by Stage/HS


/* Threads */
static OSThread mainThread;  /* Started from boot code; becomes idle thread */
static OSThread gameThread;  /* Thread that eventually does all work */

/* Thread priorities */
#define MAIN_PRIORITY 10
#define GAME_PRIORITY 10

/* Thread ID's -- Used only with debugger -- they're arbitrary */
#define MAIN_ID 3
#define GAME_ID 4

u16 *dummybuffer;
#define BUFFER 0x80200000

u64 bootStack[STACKSIZE/8];  /* For boot code.  Can reuse on boot code exit. */
u64 mainStack[STACKSIZE/8];  /* Stacks for threads... */
u64 gameStack[STACKSIZE/8];

/* Message queues */
static OSMesg      PiMessages[PI_MSGQUEUE_SIZE];
static OSMesgQueue PiMessageQ;
static OSMesg      DMAMessages[DMA_MSGQUEUE_SIZE];
static OSMesgQueue DMAMessageQ;
static OSMesg      RDPDoneMessages[RDPDONE_MSGQUEUE_SIZE];
static OSMesgQueue RDPDoneMessageQ;
static OSMesg      RetraceMessages[RETRACE_MSGQUEUE_SIZE];
static OSMesgQueue RetraceMessageQ;

/* Dummy message */
static OSMesg      dummyMsg;

/*
 * Symbols to tell us where various segments are
 * in cartridge ROM, and in RDRAM.
 */
extern char _static_seg_org[],_static_seg_size[];
#define _rsp_staticSegmentRomStart ((u32)_static_seg_org)
#define _rsp_staticSegmentRomEnd ((u32)_static_seg_org+(u32)_static_seg_size)

extern char _rom_seg_org[],_rom_seg_size[];

extern char _cfb_obj[];
#define _cfbSegmentStart (_cfb_obj)

extern char _code_bss_obj[],_code_bss_size[];
#define _codeSegmentEnd ((u32)_code_bss_obj+(u32)_code_bss_size)

/*
 * Display lists defined in static.c
 */
extern Gfx rspinit_dl[];
extern Gfx rdpinit_dl[];
extern Gfx scrnclr_dl[];

/*
 * Z-Buffer from zbuf.c; Color Frame Bufs from cfb.c
 */
extern unsigned short zbuffer[];	// Z-buffer
extern unsigned short cfb_A[];		// Two frame buffers
extern unsigned short cfb_B[];

extern char     rawData[];

/*
 * Double-buffered data structures
 * Must be declared global (rather than local to a routine) so that they
 * don't disappear while they're in use when routine exits.
 *
 * Double buffered so one can be drawn while a new one is being calculated
 */
dynamic_stuff dynamic[2];  /* Declare two copies of dynamic stuff */
OSTask        task[2];     /* Two copies of task structure */

						   /*

/*
 * Protypes for routines in this file
 */
void boot(void *arg);
static void mainproc(void *arg);
static void gameproc(void *arg);
static void gameloop(char *rsp_static_addr);
void CharOut(char cLetter,int nColor,int x,int y,int nDouble);
void SetPoint(int x,int y,int nColor);
void WriteLine(char *,int nLine,int nColor,int nDouble);
void PrintLogo(int,int);

/*
 * boot -- first routine called
 */
void boot(void *arg) {

  osInitialize();  // must be called before any osvi... function takes place
  
  osCreateThread(&mainThread, MAIN_ID, (void(*)(void *))mainproc, arg,
		 (void *)(mainStack+STACKSIZE/8), (OSPri) MAIN_PRIORITY);
  osStartThread(&mainThread);
} /* boot */

/*
 * mainproc -- invoked by boot.  Sets up, then becomes idle thread.
 */
static void mainproc(void *arg) {
  /* Note:  Not using TLB -- all our R4300 address are KSEG0 (physical) */

  osCreateThread(&gameThread, GAME_ID, gameproc, arg,
		 (void *)(gameStack+STACKSIZE/8), GAME_PRIORITY);

  /* Start VI Mgr (Video) */
  osCreateViManager(OS_PRIORITY_VIMGR);

  /* Set video mode to Low Res; Anti-Aliased; Non-interlaced; 16 bits/pixel */
  osViSetMode(&osViModeTable[OS_VI_PAL_LPN1]);

  /* Start PI Mgr for access to cartridge
   * This call creates the message queue, so we don't have to.
   */
  osCreatePiManager((OSPri) OS_PRIORITY_PIMGR, &PiMessageQ, PiMessages,
		    PI_MSGQUEUE_SIZE);

  osStartThread(&gameThread);
  /* keine ahnung warum zum Teufel wir da 'nen anderen Task brauchen
     Anyway, sehe keine Nachteile ausgenommen dem Zeitverlust des startens ;) '/
  
  /* Become the idle thread and relinquish CPU */
  osSetThreadPri(NULL, 0);
  for(;;); /* This in fact just spins, but OK since we're at priority 0 */
} /* mainproc */

/*
 * gameproc -- entry point for permanently running primary game thread
 */

static void gameproc(void *arg) {
  char     *rsp_static_addr;  /* R4300 addr where rsp_static segment loaded */
  char     *rsp_static_end;   /* R4300 addr+1 for end of the load region    */
  int      rsp_static_len,i;
  OSIoMesg dmaMb;             /* Needed (empty) for call to osPiStartDma    */
  Gfx *l;

  /* Message Queue for OS messages indicating DMA completions */
  osCreateMesgQueue(&DMAMessageQ, DMAMessages, DMA_MSGQUEUE_SIZE);

  /* Message Queue for OS messages indicating RDP done */
  osCreateMesgQueue(&RDPDoneMessageQ, RDPDoneMessages, RDPDONE_MSGQUEUE_SIZE);
  osSetEventMesg(OS_EVENT_DP, &RDPDoneMessageQ, dummyMsg);

  /* Message Queue for OS messages indicating vertical retrace */
  osCreateMesgQueue(&RetraceMessageQ, RetraceMessages, RETRACE_MSGQUEUE_SIZE);
  osViSetEvent(&RetraceMessageQ, dummyMsg, 1);

  /*
   * Load the 'rsp_static' segment from the cartridge
   *
   * This copies all static data to RAM to be accessed by RSP. Uses DMA.
   * As you know, RAM is much faster than ROM.
   */
  rsp_static_len  = _rsp_staticSegmentRomEnd - _rsp_staticSegmentRomStart;

  /* Place it right after the code/data segment in the 3rd MB of memory.
   * Will not collide with CFB's or the Z buffer. Because the texture loads
   * are so frequent, this gives a significant performance enhancement.
   */
  rsp_static_addr = (char *) _codeSegmentEnd; /* R4300 address for static segment */
  rsp_static_end  = (char *) _codeSegmentEnd + rsp_static_len;

  /* Note: dmaMb is working space used by osPiStartDma */
  osPiStartDma(&dmaMb, OS_MESG_PRI_NORMAL, OS_READ,
	       (u32)_rsp_staticSegmentRomStart, rsp_static_addr,
	       rsp_static_len, &DMAMessageQ);
  osRecvMesg(&DMAMessageQ, NULL, OS_MESG_BLOCK);  /* Wait for completion */


  /*
   * Run the main loop of the game
   */
  gameloop(rsp_static_addr);

} /* gameproc */


/*
 * gameloop -- main loop of game
 *             Called by gameproc; runs in gameThread.
 *             Parameter: rsp_static_addr, the R4300 address where the
 *                        rsp_static segment was loaded
 */
extern char sample;

static void gameloop(char *rsp_static_addr) {
/* 
        private demo data                                                      
*/
unsigned char bInfoText[]=
"\
         game index n64                 \
                                        \
            high.society\0mailcity.com   \
                                        \
  001 blast corps                       \
  002 japan league eleven beat 1997     \
  003 super mario 64                    \
  005 killer instinct gold              \
  006 cruisn usa                        \
  007 st. andrews golf course           \
  008 perfect striker                   \
  009 proyakyu king baseball            \
  010 shadows of the empire             \
  011 nba hangtime                      \
  012 mahjong master                    \
  013 wave race 64                      \
  014 pilot wings 64                    \
  015 kuiki uhabi suigo                 \
  016 wayne gretzkys 3d hockey          \
  017 mortal combat trilogy             \
  018 mario kart 64                     \
  019 turok                             \
  020 pawufurup uroyakyu                \
  021 fifa 64  (japan league)           \
  022 doraemon                          \
  023 doom 64                           \
  024 human grand prix                  \
  025 mahjong 64                        \
  026 madden 64                         \
  027 wargods                           \
  028 international superstar soccer    \
  029 mame64 (arcade games)             \
  030 dark rift                         \
  031 multi racing championship         \
  032 power league baseball 64          \
  033 tetrisphere                       \
  034 golden eye                        \
  035 clayfighter 64                    \
  036 lylat wars (starfox 64)           \
  037 baku bomberman 64                 \
  038 mischief makers                   \
  039 hexen 64                          \
  040 topgear 64                        \
  041 mace - the dark age               \
  042 f1 pole position                  \
  043 quarterback club                  \
  044 extreme-g                         \
  045 puyo puyo sun                     \
  046 diddy kong racing                 \
  047 san francisco rush                \
  048 duke nukem 3d                     \
  049 aero fighter assault              \
  050 lamborghini automobili            \
  051 wild choppers                     \
  052 wheel of fortune                  \
  053 chameleon twist                   \
  054 dual hero                         \
  055 oozumo                            \
  056 wayne gretzkeys 3d hockey 98      \
  057 wcw vs nwo world tour             \
  058 mortal kombat mythologies         \
  059 kiwame 64 pro-mahjong             \
  060 famista 64                        \
  061 pachinko 64                       \
  062 nfl quarterback 98                \
  063 snowbow kids                      \
  064 aerogauge                         \
  065 fly dragonfighter                 \
  066 fire electric pen                 \
  067 virtual pro wrestling 64          \
  068 fifa 98                           \
  069 nagano winter games               \
  070 yoshis story                      \
  071 robotron 64                       \
  072 toukon road                       \
  073 fighters destiny                  \
  074 augusta master golf 98            \
  075 mahjong classics                  \
  076 nba in the zone 98                \
  077 sim city 2000                     \
  078 tamagotchi                        \
  079 ganbare goemon                    \
  080 olympic hockey nagano 98          \
  081 nhl breakaway 98                  \
  082 jeopardy                          \
  083 1080 snowboarding                 \
  084 g a s p                           \
  085 puzzle dama                       \
  086 quake                             \
  087 airborders 64                     \
  088 rampage world tours               \
  089 pawafuru puroyakyu 5              \
  090 bomberman hero                    \
  091 nba pro 98                        \
  092 clayfighter scultor cut           \
  093 nba courtside                     \
  094 world cup 98                      \
  095 gameboy emulator                  \
  096 all star baseball 99              \
  097 bio freaks                        \
  098 forsaken                          \
  099 bust a move 2                     \
  100 wetrix                            \
  101 isss worldcup france 98           \
  102 major league baseball             \
  103 mortal combat 4                   \
  104 virtual chess                     \
  105 quest 64                          \
  106 mike piazzas strikezone           \
  107 banjo kazooie                     \
  108 offroad challenge                 \
  109 gt 64 championship                \
  110 dazaemon 3d                       \
  111 star soldier                      \
  112 f zero x                          \
  113 choro quest 64                    \
  114 super robot spirit                \
  115 mission impossible                \
  116 cruisn world                      \
  117 battle phoenix                    \
  118 rakuga kids                       \
  119 pachinco 365 nichi                \
  120 f1 world grand prix               \
";

  unsigned char cText[]="                                           yeaaahhh it is done!!! the first n64 intro by GhGiGgGh GsGoGcGiGeGtGy proudly coded by our major RsRtRaRgRe..... greeetz must go out to locke (for releasing his source), all dextrosers, all black bags, lem, kid stardust, any1 in iceage, and to flake/trsi and finally to bpoint .... watch out...     26.10.97  (list update 20.6.98)   eot @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@                                                                  \0                                                                                ";

  unsigned char *pcTemp;
  unsigned char *cPointer;
  unsigned char *cScrollPointer;
  int nII,nI,nI1,nI2,nPos=0,nDir=0,nSmooth,nCol;
  f32 fY=0.05;

  unsigned int  nStarField[MAXSTARS*2][5];
  unsigned int  nRandom[]={50,112,119,147,310,256,10,245,75,102,65,310,289,124,110,21,54,100,230,52,86,174,274,30,310,119,147,020,36,58,247,302,275,140,10,258,247,123,256,49,198,318,999};
  OSMesgQueue      intMesgQueue;
  OSMesg          intMesgBuf[20];
  OSMesg          actualMesg;
  OSContStatus     sdata[MAXCONTROLLERS];
  OSContPad        rdata[MAXCONTROLLERS];
  u8              pattern;

  int oddframe = 0;        /* Odd or even rendered frame?  Start with even. */
  int firstframe = 1;      /* First frame? */
  dynamic_stuff *generate; /* Dynamic info we're generating now */
  Gfx           *glistp0;  /* Start of this frame's dynamic display list */
  Gfx           *glistp;   /* Current position in dynamic display list */

  OSTask        *gentask;  /* Task we're generating */

  int           t,i;	   /* Just some vars */
  int *npI;
  int nPosInfo=0;

  cScrollPointer=cText;    
  nSmooth=6; // fein scrolling offset.

  osCreateMesgQueue(&intMesgQueue, intMesgBuf, 20);      //stuff for joypad
  osSetEventMesg(OS_EVENT_SI, &intMesgQueue, dummyMsg);
  osContInit(&intMesgQueue, &pattern, &sdata[0]);
  osContStartReadData(&intMesgQueue);
  osRecvMesg(&intMesgQueue, NULL, OS_MESG_BLOCK);        //stuff for joypad

  

  nI1=0;nI2=8;npI=nRandom;                                           //init for starscroller
  for (nI=0;nI<MAXSTARS*2;nI=nI+2) {
    for (nII=0;nII<5;nII++)     {
      nStarField[nI][nII]  =*npI++; //x value
      nStarField[nI+1][nII]=nI2;     //y value
      nI2+=3;
      if (nI2>240) nI2-=240;
      if(*npI==999) npI=nRandom;
    }
  }                                                      //init for starscroller
    

  while (1) {
    osContInit(&intMesgQueue, &pattern, &sdata[0]);
    osContStartReadData(&intMesgQueue);                  //joypad read....

    if (!firstframe)
      osSpTaskStart(gentask);

    /*
     * Set up pointers to dynamic stuff.  We're always generating one set
     * of dynamic data and drawing another.
     */
    generate = &(dynamic[(oddframe ? 0 : 1)]);

    /* glist portion of generated dynamic data */
    glistp0 = &(generate->glist[0]); /* remember start of list for when we start drawing */
    glistp  = glistp0;  /* This one will be incremented as list is built */

    /*
     * Tell RSP where each segment is
     */
    gSPSegment(glistp++, 0, 0x0);     /* Physical address segment */
    /* Static segment (mapping never changes) */
    gSPSegment(glistp++, STATIC_SEG,  OS_K0_TO_PHYSICAL(rsp_static_addr));
    /* Dynamic segment (mapping changes every frame) */
    gSPSegment(glistp++, DYNAMIC_SEG, OS_K0_TO_PHYSICAL(generate));

    /*
     * RSP and RDP setup, and screen clear
     */
    gSPDisplayList(glistp++, rspinit_dl); // Init routines defined in static.c
    gSPDisplayList(glistp++, rdpinit_dl);
    gDPSetColorImage(glistp++, G_IM_FMT_RGBA, G_IM_SIZ_16b, SCREEN_WD,
		     OS_K0_TO_PHYSICAL(oddframe ? cfb_A : cfb_B));
    gSPDisplayList(glistp++, scrnclr_dl);
    /* Must set color image again after zbuffer clear */
    gDPSetColorImage(glistp++, G_IM_FMT_RGBA, G_IM_SIZ_16b, SCREEN_WD,
		     OS_K0_TO_PHYSICAL(oddframe ? cfb_A : cfb_B));
    /* Set Z-buffer */
    gDPSetDepthImage(glistp++, OS_K0_TO_PHYSICAL(zbuffer));

	/* 
	 * Texture settings only need to be done once because they
	 * are the same for all the letters
	 *
	 * No mipmapping is performed (but offcourse texture filtering is on!)
	 */
	// Turn texture on, max UV's are 0x8000
	// Number of mipmaps is 1 (so set to 0)... because we're not mipmapping.
    gSPTexture(glistp++, 0x8000, 0x8000, 0, 0, G_ON);

	// Load picture into texture cache. Note that the texture isn't
	// pre-mipmapped and we're not doing it realtime either (should be doing really)
    gDPLoadTextureBlock (glistp++,hs_logo, G_IM_FMT_RGBA, G_IM_SIZ_16b, 32, 32, 0,
	  G_TX_WRAP | G_TX_NOMIRROR, G_TX_WRAP | G_TX_NOMIRROR,
	  G_TX_NOMASK, G_TX_NOMASK, G_TX_NOLOD, G_TX_NOLOD);



    /*
     * Put an END on the top-level display list.
     */
    gDPFullSync(glistp++); /* Only need this if you want 'accurate' SP done? */
    gSPEndDisplayList(glistp++);


    /*
     * Build graphics task to execute the display list we just built.
	 *
     * Note that all addresses are KSEG0, even if used by the RSP.
     * Conversion is done by the task routines.
     */
    gentask = &(task[oddframe ? 0 : 1]);
    gentask->t.type            = M_GFXTASK;
    gentask->t.flags           = 0x0;
    gentask->t.ucode_boot      = (u64*) rspbootTextStart;
    gentask->t.ucode_boot_size = ((int)rspbootTextEnd - (int)rspbootTextStart);
    gentask->t.ucode           = (u64*) gspFast3DTextStart; /* use XBUS */
    gentask->t.ucode_data      = (u64*) gspFast3DDataStart;
    gentask->t.ucode_size      = 4096;
    gentask->t.ucode_data_size = 2048;
    gentask->t.dram_stack      = (u64*) rspdrambuf1;
    gentask->t.dram_stack_size = 1024;
    gentask->t.output_buff     = (u64*) NULL;
    gentask->t.output_buff_size= (u64*) NULL;
    gentask->t.yield_data_ptr  = (u64*) NULL; /* Graphics only - no yielding */
    gentask->t.yield_data_size = 0x0;
	// this is where we specify the splay list
    gentask->t.data_ptr        = (u64*) glistp0;
    gentask->t.data_size       = ((int) glistp - (int) glistp0);

    /*
     * Flush the whole cache.  Should just do parts of it.
     */
    osWritebackDCacheAll();


    if (!firstframe)
      osRecvMesg(&RDPDoneMessageQ, NULL, OS_MESG_BLOCK);
    osViSwapBuffer(oddframe ? cfb_B : cfb_A);



     /*
     * No longer the first frame
     */
    firstframe = 0;
 
    /*
     * Switch to our other set of variables
     */
    oddframe ^= 1;

  /* ok break.....
  hier (an dieser stelle) ist der ganze 3d-shit schon vorbei. 3d-shit ist
  gut, eigentlich wird ja nur der screen gelscht. Trotzdem ist einigermaen
  einfach 3d-action einzubauen. ab diesem zeitpunkt wird der framebuffer
  (ermittelt via osviGetCurrent(Next)Framebuffer) direkt per cpu
  beschrieben. hence, alles was jetzt kommt ist im vordergrund zu sehen.
  screenmode = 2byte/pixel dh. einODERn der pixel ist nicht ntig.
  (um sichtbare pixel nicht mit 0x0000 (=black) zu berschreiben.)

  wie gesagt, etwas lame, aber gut geeignet um zumindest irgendwas auf den
  screen zu putten.
  */


  osRecvMesg(&intMesgQueue, NULL, OS_MESG_BLOCK);   /* huhu controller */
  osContGetReadData(&rdata[0]);                     /* auslesen fertig??*/



  for (nI=0;nI<MAXSTARS*2;nI=nI+2) {
    nStarField[nI][0]-=4;
    if(nStarField[nI][0]>400)   nStarField[nI][0]=nStarField[nI][0]+320;
    if(nStarField[nI][0]<320&&nStarField[nI+1][0]<240) SetPoint(nStarField[nI][0],nStarField[nI+1][0],RGB(31,31,31));

  }
  for (nI=0;nI<MAXSTARS*2;nI=nI+2) {
    nStarField[nI][1]-=3;
    if(nStarField[nI][1]>400)   nStarField[nI][1]=nStarField[nI][1]+320;                                   
    if(nStarField[nI][1]<320&&nStarField[nI+1][1]<240) SetPoint(nStarField[nI][1],nStarField[nI+1][1],RGB(25,25,31));

  } 
  for (nI=0;nI<MAXSTARS*2;nI=nI+2) {
    nStarField[nI][2]-=2;
    if(nStarField[nI][2]>400)   nStarField[nI][2]=nStarField[nI][2]+320;
    if(nStarField[nI][2]<320&&nStarField[nI+1][2]<240) SetPoint(nStarField[nI][2],nStarField[nI+1][2],RGB(19,19,31));

  }
  for (nI=0;nI<MAXSTARS*2;nI=nI+2) {
    nStarField[nI][3]-=1;
    if(nStarField[nI][3]>400)   nStarField[nI][3]=nStarField[nI][3]+320;
    if(nStarField[nI][3]<320&&nStarField[nI+1][3]<240) SetPoint(nStarField[nI][3],nStarField[nI+1][3],RGB(13,13,31));

  }
  if (oddframe) {
    for (nI=0;nI<MAXSTARS*2;nI=nI+2) {
      nStarField[nI][4]-=1;
      if(nStarField[nI][4]>400)   nStarField[nI][4]=nStarField[nI][4]+320;
      if(nStarField[nI][4]<320&&nStarField[nI+1][4]<240) SetPoint(nStarField[nI][4],nStarField[nI+1][4],RGB(7,7,31));
     }
   }
  

        if (!(rdata[0].button&CONT_START))nSmooth-=2;
        if (nSmooth<0)  {
          nSmooth=6;
          cScrollPointer++;
          while(*cScrollPointer>='A'&&*cScrollPointer<='Z') cScrollPointer++;
          if (*cScrollPointer==0x0000) cScrollPointer=cText;
        }
        nI=nSmooth+4;
        cPointer=cScrollPointer;
        for(nI1=0;nI1<40;nI1++)   {
          nCol=RGB(20,10,31);
          if (*cPointer=='G')   {
                cPointer++;
                nCol=RGB(31,31,8);
          }
          if (*cPointer=='R')   {
                cPointer++;
                nCol=RGB(31,10,10);
          }
          CharOut(*cPointer++,nCol,nI,220,1);
          nI+=8;
	}


//  WriteLine("...   h i g h    s o c i e t y    ...",0,RGB(31,8,19),1);
  PrintLogo(0,4);
  pcTemp=bInfoText;

  // joypad: u_jpad == joaypad up!

  if(MAXINFO>16)        {
    if((rdata[0].button&CONT_UP)&&(nPosInfo>0)) nPosInfo--;
    if((rdata[0].button&CONT_DOWN)&&(nPosInfo+15<MAXINFO)) nPosInfo++;

  }
  pcTemp+=nPosInfo*40;
  for (nI=0;nI<14;nI++)  {
    WriteLine(pcTemp,nI+9,RGB(4,31,31),0);
    pcTemp+=40;
  }



/*     dummybuffer=(u16 *)osViGetCurrentFramebuffer();
     dummybuffer+=(nPos*320);
     for (nI=0;nI<1280;nI++)      {
        *dummybuffer++=0xfffe;
     }
 
     if (nDir==0)nPos++;
     else nPos--;
     if (nPos>232||nPos<1) nDir=!nDir; */




    if (MQ_IS_FULL(&RetraceMessageQ))
      osRecvMesg(&RetraceMessageQ, NULL, OS_MESG_BLOCK);
    osRecvMesg(&RetraceMessageQ, NULL, OS_MESG_BLOCK);

  } /* while(1) */

} /* gameloop */

void CharOut(char cLetter,int nColor,int x,int y,int nDouble)       {

unsigned char cFont[512] = {
        0x3c, 0x66, 0x6e, 0x6e, 0x60, 0x62, 0x3c, 0x00, 0x3F, 0x03, 0x63, 0x7F, 0x63, 0x63, 0x63, 0x00, 
	0x7E, 0x03, 0x63, 0x7E, 0x63, 0x63, 0x7E, 0x00, 0x3F, 0x00, 0x60, 0x60, 0x60, 0x60, 0x3F, 0x00, 
	0x7E, 0x03, 0x63, 0x63, 0x63, 0x63, 0x7E, 0x00, 0x3F, 0x00, 0x60, 0x78, 0x60, 0x60, 0x3F, 0x00, 
	0x3F, 0x00, 0x60, 0x78, 0x60, 0x60, 0x60, 0x00, 0x3F, 0x00, 0x60, 0x67, 0x63, 0x63, 0x3E, 0x00, 
	0x63, 0x03, 0x63, 0x7F, 0x63, 0x63, 0x63, 0x00, 0x18, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 
	0x0C, 0x00, 0x0C, 0x0C, 0x0C, 0x6C, 0x38, 0x00, 0x63, 0x06, 0x6C, 0x78, 0x6C, 0x66, 0x63, 0x00, 
	0x60, 0x00, 0x60, 0x60, 0x60, 0x60, 0x7F, 0x00, 0x63, 0x00, 0x7F, 0x6B, 0x63, 0x63, 0x63, 0x00, 
	0x63, 0x00, 0x7B, 0x7F, 0x6F, 0x67, 0x63, 0x00, 0x3E, 0x03, 0x63, 0x63, 0x63, 0x63, 0x3E, 0x00, 
	0x7E, 0x03, 0x63, 0x63, 0x7E, 0x60, 0x60, 0x00, 0x3E, 0x03, 0x63, 0x63, 0x63, 0x67, 0x3F, 0x00, 
	0x7E, 0x03, 0x63, 0x63, 0x7E, 0x6E, 0x67, 0x00, 0x3F, 0x00, 0x60, 0x3E, 0x03, 0x03, 0x7E, 0x00, 
	0x7E, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x63, 0x00, 0x63, 0x63, 0x63, 0x63, 0x3E, 0x00, 
	0x63, 0x00, 0x63, 0x63, 0x36, 0x1C, 0x08, 0x00, 0x63, 0x00, 0x63, 0x6B, 0x7F, 0x77, 0x63, 0x00, 
	0x63, 0x00, 0x3E, 0x1C, 0x3E, 0x63, 0x63, 0x00, 0x63, 0x00, 0x63, 0x3E, 0x1C, 0x1C, 0x1C, 0x00, 
	0x7E, 0x00, 0x0C, 0x18, 0x30, 0x60, 0x7E, 0x00, 0x3C, 0x30, 0x30, 0x30, 0x30, 0x30, 0x3C, 0x00, 
	0x0C, 0x12, 0x30, 0x7C, 0x30, 0x62, 0xFC, 0x00, 0x3C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x3C, 0x00, 
	0x00, 0x18, 0x3C, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x00, 0x10, 0x30, 0x7F, 0x7F, 0x30, 0x10, 0x00, 
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x00, 
	0x66, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0xFF, 0x66, 0xFF, 0x66, 0x66, 0x00, 
	0x18, 0x3E, 0x60, 0x3C, 0x06, 0x7C, 0x18, 0x00, 0x62, 0x66, 0x0C, 0x18, 0x30, 0x66, 0x46, 0x00, 
	0x3C, 0x66, 0x3C, 0x38, 0x67, 0x66, 0x3F, 0x00, 0x06, 0x0C, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 
	0x0C, 0x18, 0x30, 0x30, 0x30, 0x18, 0x0C, 0x00, 0x30, 0x18, 0x0C, 0x0C, 0x0C, 0x18, 0x30, 0x00, 
	0x00, 0x66, 0x3C, 0xFF, 0x3C, 0x66, 0x00, 0x00, 0x00, 0x18, 0x18, 0x7E, 0x18, 0x18, 0x00, 0x00, 
	0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x30, 0x00, 0x00, 0x00, 0x7E, 0x00, 0x00, 0x00, 0x00, 
	0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x03, 0x06, 0x0C, 0x18, 0x30, 0x60, 0x00, 
	0x3E, 0x03, 0x63, 0x63, 0x63, 0x63, 0x3E, 0x00, 0x0C, 0x00, 0x3C, 0x0C, 0x0C, 0x0C, 0x0C, 0x00, 
	0x3C, 0x00, 0x06, 0x0C, 0x30, 0x60, 0x7E, 0x00, 0x3E, 0x00, 0x03, 0x0E, 0x03, 0x63, 0x3E, 0x00, 
	0x06, 0x00, 0x1E, 0x36, 0x66, 0x7F, 0x06, 0x00, 0x7F, 0x00, 0x60, 0x7E, 0x03, 0x03, 0x7E, 0x00, 
	0x3E, 0x00, 0x60, 0x7E, 0x63, 0x63, 0x3E, 0x00, 0x7F, 0x00, 0x06, 0x0C, 0x18, 0x18, 0x18, 0x00, 
	0x3E, 0x03, 0x63, 0x3E, 0x63, 0x63, 0x3E, 0x00, 0x3E, 0x03, 0x63, 0x3F, 0x03, 0x63, 0x3E, 0x00, 
	0x00, 0x00, 0x18, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x18, 0x18, 0x30, 
	0x0E, 0x18, 0x30, 0x60, 0x30, 0x18, 0x0E, 0x00, 0x00, 0x00, 0x7E, 0x00, 0x7E, 0x00, 0x00, 0x00, 
	0x70, 0x18, 0x0C, 0x06, 0x0C, 0x18, 0x70, 0x00, 0x3C, 0x66, 0x06, 0x0C, 0x18, 0x00, 0x18, 0x00, 
	} ;
	int nI,nI1;
	char	cBuffer;
	u16 *Cfb;
        Cfb=(u16 *)osViGetNextFramebuffer();
        Cfb+=(x+y*320)-8;

        switch (cLetter)                {
          case 32: cLetter=32;
            break;        
          case 34:  cLetter=34;
            break;
          case '.': cLetter=46;
            break;
          case '-': cLetter=45;
            break;
          case ',': cLetter=44;
            break;
          case '(': cLetter=40;
            break;
          case ')': cLetter=41;
            break;
          case '!': cLetter=33;
            break;
          case '@': cLetter=28;
            break;
          case 0:
            break;
          case '/': cLetter=47;
            break;
          default:
            if (cLetter>0x2f&&cLetter<0x3a) {
              cLetter=(cLetter-0x30)+48;
            }
            else  cLetter=cLetter-96;
            break;
        }


        for (nI=0;nI<9;nI++)    {
          cBuffer=cFont[(cLetter*8)+nI-1];
          for (nI1=0;nI1<8;nI1++)     {
            if (nDouble)  {
              if (cBuffer&128) *(Cfb+320)=nColor;
              if (cBuffer&128) *Cfb++=nColor;
              else Cfb++;
              cBuffer<<=1;
            }
            else  {
              if (cBuffer&128) *Cfb++=nColor;
              else Cfb++;
              cBuffer<<=1;
            }
          }
          if(nDouble) Cfb+=632;
          else Cfb+=312;
  	}
        
}
			
	
void SetPoint(int x,int y, int nColor)    {

  u16 *Cfb;
  Cfb=(u16  *)osViGetNextFramebuffer();
  Cfb+=(x+y*320);

  *Cfb=nColor;
     
}


void WriteLine(char *pcText,int nLn,int nCol,int nDouble)    {
  int nI;

  for (nI=2;nI<39;nI++) {
    CharOut(*pcText++,nCol,nI*8,nLn*(9*(nDouble+1)),nDouble);
  }
}

void PrintLogo(int x,int y)        {
  int nI,nI1,nI2;
  char *Source;
  char *Cfb;
  
  Cfb=(char  *)osViGetNextFramebuffer();
  Cfb+=(x+y*320);
  Source=rawData;

  for (nI=0;nI<54400;)      {

    nI+=5;

    if (*Source) *Cfb=*Source;
    Cfb++;
    Source++;
    if (*Source) *Cfb=*Source;
    Cfb++;
    Source++;
    if (*Source) *Cfb=*Source;
    Cfb++;
    Source++;
    if (*Source) *Cfb=*Source;
    Cfb++;
    Source++;
    if (*Source) *Cfb=*Source;
    Cfb++;
    Source++;
  }

}
